import { getFrom, isPromise } from './helpers';
export const createInstance = (factory, deps) => (deps.some(isPromise)
    ? Promise.all(deps).then(resolvedDeps => factory(...resolvedDeps))
    : factory(...deps));
export const tokens = (...names) => names;
export const asFactory = (factory, inject = factory.inject) => (container) => (typeof inject === 'function' ? createInstance(factory, inject(container)) :
    Array.isArray(inject) ? createInstance(factory, inject.map(getFrom(container))) :
        factory(container));
export const asClass = (constructor, inject = constructor.inject) => asFactory((...args) => Reflect.construct(constructor, args), inject);
