"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var all_names_1 = require("./utils/all-names");
var cleaner = function (instance, container, name) {
    container[name] = null;
};
var decorateFactory = function (factory) { return [
    factory,
    cleaner,
]; };
var decorateTupple = function (_a) {
    var factory = _a[0], initilizer = _a[1];
    return [
        factory,
        function (instance, container, name) {
            initilizer(instance, container, name);
            cleaner(instance, container, name);
        },
    ];
};
var decorateItemBinding = function (itemBinding) { return (typeof itemBinding === 'function'
    ? decorateFactory(itemBinding)
    : decorateTupple(itemBinding)); };
var decorateFactories = function (factories) {
    return all_names_1.default(factories).reduce(function (newObject, name) { return Object.defineProperty(newObject, name, __assign(__assign({}, Object.getOwnPropertyDescriptor(factories, name)), { value: decorateItemBinding(factories[name]) })); }, Object.create(null));
};
var multiple = function (bindingOrFactories) { return (!Array.isArray(bindingOrFactories) && typeof bindingOrFactories === 'object'
    ? decorateFactories(bindingOrFactories)
    : decorateItemBinding(bindingOrFactories)); };
exports.default = multiple;
