import { Services } from '../types';
export declare type Factory<D extends unknown[], T> = (...dependencies: D) => T;
export declare type Constructor<D extends unknown[], T> = {
    new (...dependencies: D): T;
};
export declare type AsyncDeps<D extends unknown[]> = {
    [index in keyof D]: D[index] | Promise<D[index]>;
};
export declare type Async<C extends {}> = {
    [p in keyof C]: C[p] | Promise<C[p]>;
};
declare type Injector<C extends object, D extends any[]> = {
    (container: C): D;
};
declare type WithInject<Inject> = {
    inject: Inject;
};
declare type FromContainer<C extends {}, T> = {
    (container: C): T;
    (container: Async<C>): Promise<T>;
};
export declare const createInstance: {
    <D extends any[], T>(factory: Factory<D, T>, deps: D): T;
    <D extends any[], T>(factory: Factory<D, T>, deps: AsyncDeps<D>): Promise<T>;
};
export declare const tokens: <token extends string | symbol, Items extends token[]>(...names: Items) => Items;
export declare const asFactory: {
    <D extends any[], C extends object, T>(factory: Factory<D, T> & WithInject<Injector<C, D>>): FromContainer<C, T>;
    <D extends any[], C extends object, T>(factory: Factory<D, T>, injector: Injector<C, D>): FromContainer<C, T>;
    <D extends any[], T, token extends string | symbol, tokens extends token[]>(factory: Factory<D, T> & WithInject<tokens>): FromContainer<Services<tokens, D>, T>;
    <D extends any[], T, token extends string | symbol, tokens extends token[]>(factory: Factory<D, T>, tokens: tokens): FromContainer<Services<tokens, D>, T>;
    <C extends object, T>(factory: Factory<[C], T>): Factory<[C], T>;
};
export declare const asClass: {
    <D extends any[], C extends object, T>(constructor: Constructor<D, T> & WithInject<Injector<C, D>>): FromContainer<C, T>;
    <D extends any[], C extends object, T>(constructor: Constructor<D, T>, inject: Injector<C, D>): FromContainer<C, T>;
    <D extends any[], token extends string | symbol, T, tokens extends token[]>(constructor: Constructor<D, T> & WithInject<tokens>): FromContainer<Services<tokens, D>, T>;
    <D extends any[], T, token extends string | symbol, tokens extends token[]>(constructor: Constructor<D, T>, inject: tokens): FromContainer<Services<tokens, D>, T>;
};
export {};
