"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.asClass = exports.asFactory = exports.tokens = exports.createInstance = void 0;
var helpers_1 = require("./helpers");
exports.createInstance = function (factory, deps) { return (deps.some(helpers_1.isPromise)
    ? Promise.all(deps).then(function (resolvedDeps) { return factory.apply(void 0, resolvedDeps); })
    : factory.apply(void 0, deps)); };
exports.tokens = function () {
    var names = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        names[_i] = arguments[_i];
    }
    return names;
};
exports.asFactory = function (factory, inject) {
    if (inject === void 0) { inject = factory.inject; }
    return function (container) { return (typeof inject === 'function' ? exports.createInstance(factory, inject(container)) :
        Array.isArray(inject) ? exports.createInstance(factory, inject.map(helpers_1.getFrom(container))) :
            factory(container)); };
};
exports.asClass = function (constructor, inject) {
    if (inject === void 0) { inject = constructor.inject; }
    return exports.asFactory(function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return Reflect.construct(constructor, args);
    }, inject);
};
